#include <stdio.h>
#include <queue>
using namespace std;

struct Node
{
       int key;
       int next;
} nodes[120000]; //~1MB 
int cnt;

int table[10000];
int N, M;
void init()
{
     scanf("%d%d", &N, &M);
     for (int i = 0; i < N; i++)
      table[i] = -1;
      
     for (int i = 0; i < M; i++)
     {
         int a, b;
         scanf("%d%d", &a, &b);
         a--; b--;
         if (a == 1) continue;
         
         int save = table[a];
         table[a] = cnt;
         nodes[cnt].key = b;
         nodes[cnt++].next = save;
     }
}
    
int used[110000]; //~500KB
bool DFS(int k)
{
    if (k == 1) return 0;
      
    for (int v1 = table[k]; v1 != -1; v1 = nodes[v1].next) 
     if (!used[v1]) {used[v1] = 1; return DFS(nodes[v1].key);}
     else return 1; 
}

void DFS1(int k)
{
     used[k] = 1; 
     for (int v1 = table[k]; v1 != -1; v1 = nodes[v1].next)
      if (!used[nodes[v1].key]) DFS1(nodes[v1].key);
}
    
long long W[10000], UnAdded[10000];
int main()
{
    init();
    DFS1(0);
    if (!used[1]) {printf("0\n"); return 0;}
    
    memset(used, 0, sizeof(used));
    if (DFS(0)) {printf("inf\n"); return 0;}
    
    long long MOD = (long long)1000000000*10000;
    
    queue<int> q;
    q.push(0);
    
    W[0] = 1;
    UnAdded[0] = 1;
    memset(used, 0, sizeof(used));

    while (!q.empty())
    {
          int v = q.front();         
          q.pop();
          used[v] = 0;
          for (int v1 = table[v]; v1 != -1; v1 = nodes[v1].next)
          {
              W[      nodes[v1].key] += UnAdded[v];
              UnAdded[nodes[v1].key] += UnAdded[v];
              UnAdded[nodes[v1].key] %= MOD;
              W[      nodes[v1].key] %= MOD;
              
              if (!used[nodes[v1].key]) {used[nodes[v1].key] = 1; q.push(nodes[v1].key);};
          }
          UnAdded[v] = 0;
    }
    if (W[1] > 1000000000)
     printf("%09d\n", (int)(W[1]%1000000000));
    else printf("%d\n", (int)(W[1]%1000000000)); 
    return 0;    
}
