#include <stdio.h>
#include <math.h>
#include <iomanip>
using namespace std;

int min(int a, int b)
{
    return (a < b)?a:b;
}
int max(int a, int b)
{
    return (a > b)?a:b;
}
int sTreeMin[110000], sTreeMax[110000], M[50000];

int buildMin(int i, int j, int node)
{
     //cout << i << " " << j << endl;
     if (i == j) return sTreeMin[node] = M[i];
     else return sTreeMin[node] = min( buildMin(i, (i + j)/2, 2*node),
                                buildMin((i + j)/2 + 1, j, 2*node + 1) );   
}

int buildMax(int i, int j, int node)
{
     if (i == j) return sTreeMax[node] = M[i];
     else return sTreeMax[node] = max( buildMax(i, (i + j)/2, 2*node),
                                buildMax((i + j)/2 + 1, j, 2*node + 1) );
}

int askMin(int i, int j, int a, int b, int node)
{
    //cout << "In: " << i << " " << j << ": " << sTreeMin[node] << endl;
    if (a <= i && j <= b) return sTreeMin[node];
    int left = INT_MAX;
    int right = INT_MAX;
    if (a <= (i + j)/2) left = askMin(i, (i + j)/2, a, b, 2*node);
    if (b > (i + j)/2) right = askMin((i + j)/2 + 1, j, a, b, 2*node + 1);
    
    return min(left, right);
}

int askMax(int i, int j, int a, int b, int node)
{
    if (a <= i && j <= b) return sTreeMax[node];
    
    int left = 0;
    int right = 0;
    if (a <= (i + j)/2) left = askMax(i, (i + j)/2, a, b, 2*node);
    if (b > (i + j)/2) right = askMax((i + j)/2 + 1, j, a, b, 2*node + 1);
    
    return max(left, right);
}

int main()
{
    int N, Z;
    scanf("%d%d", &N, &Z);
    for (int i = 0; i < N; i++)
     scanf("%d", &M[i]);
    
    buildMin(0, N - 1, 1);
    buildMax(0, N - 1, 1);
    askMin(0, N - 1, 0, 3, 1);
    
    for (int i = 0; i < Z; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        a--; b--;
        printf("%d\n", askMax(0, N - 1, a, b, 1) - askMin(0, N - 1, a, b, 1));
    }
    return 0;
}
